{
   [big_fury]
  888888888    8888  888888888888  8888     888888888     8888      8888   888888888
8888888888888  8888  888888888888  8888   8888888888888   8888      8888 8888888888888
8888     8888              88888         8888       8888  8888      8888 8888     8888
888888888      8888      888888    8888 8888         8888 8888      8888 888888888
  8888888888   8888     88888      8888 8888         8888 8888      8888   88888888888
       888888  8888   88888        8888 8888         8888 8888      8888         888888
8888      8888 8888  88888         8888  8888       8888  8888      8888 8888      8888
8888888888888  8888 88888888888888 8888   8888888888888    888888888888  8888888888888
  8888888888   8888 88888888888888 8888     888888888       8888888888     8888888888

  Drag'n'Drop d'lments dans une TListBox.
  Par SiZiOUS, le 29 aout 2005
  http://sbibuilder.shorturl.com/

  Ce petit exemple permet le dplacement d'lments avec un simple glisser dposer,
  dans une ListView.

  Vous tes libre de faire ce que vous voulez avec ce code.
}


unit Unit1;

interface

uses
  Windows, sysutils, Classes, Controls, Forms, StdCtrls, ShellApi;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    Label1: TLabel;
    Button1: TButton;
    procedure ListBox1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure ListBox1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.ListBox1DragDrop(Sender, Source: TObject; X, Y: Integer);
var
  Pt : TPoint;
  Exists : boolean;
  NewInd,
  _selected  : integer;
  itemcpt : string;

begin
  if Sender = Source then
    with TListBox(Sender) do
    begin
      _selected := ItemIndex;
      Pt.X := X;
      Pt.Y := Y;
      Exists := False;
      NewInd := ItemAtPos(Pt, Exists); //avoir l'lment de destination.
      //la variable exists ne sert  rien ici.
      if NewInd = -1 then Exit;
      itemcpt :=  Items[_selected];

      //dterminer la direction
      if NewInd < _selected then
      begin
        Items.Insert(NewInd, itemcpt);
        Items.Delete(_selected + 1);
      end else begin
        Items.Delete(_selected);
        if NewInd >= Items.Count then
          NewInd := Items.Add(itemcpt) //on ajoute en dehors de la liste
        else Items.Insert(NewInd, itemcpt);
      end;

      ItemIndex := NewInd; //selectionn l'lment fraichement dplac.
    end;
end;

procedure TForm1.ListBox1DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  { On accepte que les lements provenant de notre listbox.
    equivalent  :

    if Sender is ListBox1 then
      Accept := True
    else Accept := False;
  }
  Accept := Sender = ListBox1;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  (* Ceci c'est pour ouvrir le navigateur avec mon adresse. Ca n'a effectivement
      voir avec le code... ;) *)
  ShellExecute(Handle, 'open', 'http://sbibuilder.shorturl.com/', '', '',
    SW_SHOWNORMAL);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  { Vous pouvez mettre ceci dans l'inspecteur de proprit.
    je l'ai mis l car a vite de l'oublier }
  ListBox1.DragMode := dmAutomatic;
end;

end.
